﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;

using System.Windows.Media.Imaging;
namespace dynamicbitmap
{
    public partial class MainPage : UserControl
    {
        public MainPage()
        {
            InitializeComponent();
        }

        private void button1_Click(object sender, RoutedEventArgs e)
        {
            WriteableBitmap wbmap = new WriteableBitmap(256, 256);
            for (int x = 0; x < 256; x++)
            {
                for (int y = 0; y < 256; y++)
                {
                    wbmap.setPixel(x, y, Color.FromArgb(255, (byte)(x * x + y), (byte)(y * y + x), (byte)(x + y)));
                }
            }
            image1.Source = wbmap;
            /*
            WriteableBitmap wbmap = new WriteableBitmap(100, 100);
            wbmap.Pixels[0] = 255 << 24;
            wbmap.setPixel(10, 9, Color.FromArgb(255, 0, 255, 0));
            image1.Source = wbmap;
             * */
        }
    }
    public static class bitmapextensions
    {
        public static void setPixel(
   this WriteableBitmap wbm,
   int x, int y, Color c)
        {
            if (y > wbm.PixelHeight - 1 ||
                    x > wbm.PixelWidth - 1) return;
            if (y < 0 || x < 0) return;
            wbm.Pixels[y * wbm.PixelWidth + x] = c.A << 24 |
                                              c.R << 16 | c.G << 8 | c.B;
        }
        public static Color getPixel(
              this WriteableBitmap wbm, int x, int y)
        {
            if (y > wbm.PixelHeight - 1 ||
                 x > wbm.PixelWidth - 1)
                return Color.FromArgb(0, 0, 0, 0);
            if (y < 0 || x < 0)
                return Color.FromArgb(0, 0, 0, 0);
            byte[] ARGB = BitConverter.GetBytes(
               wbm.Pixels[y * wbm.PixelWidth + x]);
            return Color.FromArgb(
             ARGB[3], ARGB[2], ARGB[1], ARGB[0]);
        }
    }
}
